      Program GenFit
      Implicit NONE
C
      Integer NAtoms, MaxL
      Parameter (NAtoms = 4, MaxL = 5)
C
      Double precision Limits(2,5,4)
      Character*1 AngMom(MaxL), Atom(NAtoms)
      Double precision Scale
      Integer Sizes(MaxL, NAtoms), AtSiz, ShlSiz, MolSiz, Mol(NAtoms)
      Integer L, N, I
      Double precision Exponent
C
      Data AngMom /'s', 'p', 'd', 'f', 'g'/
      Data Atom /'H', 'C', 'O', 'K'/
      Data Mol / 16,   8,   4,   1/ ! Nr of atoms of each in K+:12c4
      Data Limits /
C     H s through H g
     $   13.02d0, 0.244d0,   13.737d0, 0.849d0,
     $   1.454d0, 1.454d0,   0.0d0,    0.0d0,
     $   0.0d0,   0.0d0,
C     C s  through C g
     $   13330.d0,  0.3192d0,     6674.439d0, 0.3113d0,
     $   665.550d0, 0.3034d0,     9.989d0,    0.7017d0,
     $   1.1d0,     1.1d0,
C     O s through O g
     $   23440.d0,    0.6046d0,     11737.7d0, 0.5776d0,
     $   11721.185d0, 0.5506d0,     18.885d0,  1.4603d0,
     $   2.37d0,      2.37d0,
C     K s through K g
     $   335465.76134d0, 0.036411992d0,
     $   170021.9673d0,  0.192725127d0,
     $   167733.8206d0,  0.088205996d0,
     $   2290.026732d0,  0.244519131d0,
     $   1.88d0,         0.14d0 /
C
C
C
      Read (5, *) Scale
C
C
C
      Write( 6, 9000)
      Do N = 1, NAtoms
C
         Do L = 1, MaxL
            Sizes(L, N) = 0
C
            Exponent = Limits( 1, L, N)
            If ( Exponent .gt. 0.0d0) then
 1000          Continue
               Write(6, 9010) Atom(N), AngMom(L), Exponent
               Sizes(L, N) = Sizes(L, N) + 1
               If ( Exponent .gt. Limits(2, L, N) ) then
                  Exponent = Exponent / Scale
                  Goto 1000
               EndIf
            EndIf
C
         EndDo
      EndDo
      Write (6, 9020)
C
 9000 Format('basis')
 9010 Format(A1, 1X, A1/F20.6, 5X, '1.0')
 9020 Format('end')
C
C     Now figure out about the size of this basis set
C
      MolSiz = 0
      Write (6, 9100), AngMom
      Do N = 1, NAtoms
         AtSiz = 0
         ShlSiz = 0
         Do L = 1, MaxL
            ShlSiz = ShlSiz + L
            AtSiz = AtSiz + ShlSiz * Sizes(L, N)
         EndDo
         MolSiz = MolSiz + AtSiz * Mol(N)
         Write (6, 9110) Atom(N), (Sizes(i, N), i=1,MaxL), AtSiz
      EndDo
      Write (6, 9120) MolSiz, MolSiz/293d0
C
 9100 Format('# Size information'/
     $       '# Atom', 5(2X,A1), 5X, 'Total bf')
 9110 Format('# ', A1, 3X, 5(1X,I2), 5X, I8)
 9120 Format('# Total size of K+:12c4   ', I8,
     $   ' (', F5.2, 'x expansion)')
C
      Stop
      End
